;;Pong 1/4 K.  The smallest Atari 2600 Game AFAIK at only 343 Bytes
;;By Rick Skrbina 

	processor 6502
	include "vcs.h"
	include "macro.h"
	
	
	seg.u vars
	org $80
P0_Y			ds 1
P0_End			ds 1
P1_End			ds 1
P1_Y			ds 1
Ball_Y			ds 1
Ball_X			ds 1
Ball_Status		ds 1
;;D0 1=up D1 1=right
Game			ds 1
;;As long as Game is something other than 0, game logic will be skiped
	
	seg Code
	
	org $F000
	
	repeat 3584	;3584 1536
	.byte $FF
	repend
	
	org $FE00
	
Start	

;	sei
	cld
	
	ldx #0
	txa
;	tay
Clear_Stack
	dex
	txs
	pha
	bne Clear_Stack
	

	lda #70		;80
	
	sta COLUBK
	

	sta P0_Y
	sta P1_Y
	
	
	sta Game
	
	sta Ball_Y
	sta Ball_X

	
Start_Frame

	lda #$82
	sta VBLANK
	sta VSYNC
	

	
	sta WSYNC
	sta WSYNC
	sta WSYNC
	

	lda #0
	sta VSYNC

	

	lda #35		;38 36
	sta TIM64T



	ldx #4
	lda Ball_X
	ldy #0
Pos_Loop
	sec
	sta WSYNC
	sta HMCLR
Div_Loop
	sbc #15
	bcs Div_Loop
	eor #7
	asl
	asl
	asl
	asl
	sta.wx HMP0,X
	sta RESP0,X
	sta WSYNC
	sta HMOVE
	lda Positions,Y
	iny
	dex
	cpx #1
	bne Pos_Loop


Vertical_Blank
	lda INTIM
	bpl Vertical_Blank


	

	
	
	lda #$80
	sta VBLANK

	

	

	
	
	clc
	lda P0_Y
	adc #24
	sta P0_End
	
	clc
	lda P1_Y
	adc #24
	sta P1_End
	
	

	

	
	ldy #192		;187
	ldx #%00000010
Picture
	sta WSYNC
	
	cpy P0_End
	bne Skip_M0


	
	stx ENAM0
	
	jmp Check_Ball
	
Skip_M0

	cpy P0_Y
	bne Check_Ball

	lda #0
	sta ENAM0
	
Check_Ball

	cpy Ball_Y
	bne No_Ball
	
	stx ENABL
	jmp Check_M1
	
No_Ball
	lda #0
	sta ENABL
	
Check_M1
	
	cpy P1_End
	bne Skip_M1
	
	stx ENAM1
Skip_M1
	cpy P1_Y
	bne Done_M1
	
	lda #0
	sta ENAM1
	
Done_M1
	

	dey
	bne Picture
	



	sty ENAM0
	sty ENAM1
	lda #$82
	sta WSYNC
	sta VBLANK
	
	
	
	lda #$2B	;26
	sta TIM64T
	
	bit INPT4
	bmi Button_Not_Pushed
	
	lda #0
	sta Game
	
Button_Not_Pushed

	lda SWCHA
	and #%00010000	;P0 Up
	beq Move_P0_Up
	lda SWCHA
	and #%00100000
	beq Move_P0_Down
	lda SWCHA
	and #%00000001
	beq Move_P1_Up
	lda SWCHA
	and #%00000010
	beq Move_P1_Down
	jmp No_Movement
	
Move_P0_Up
	inc P0_Y
	jmp No_Movement
	
Move_P0_Down
	dec P0_Y
	jmp No_Movement
	
Move_P1_Up
	inc P1_Y
	.byte $2c		
	
Move_P1_Down
	dec P1_Y
	
No_Movement

	lda Game
	bne Skip_Logic

	lda Ball_Status
	and #%00000001
	beq Move_Ball_Down
	
	inc Ball_Y
	jmp Done_Moving_Ball
	
Move_Ball_Down
	dec Ball_Y
	
Done_Moving_Ball


	lda Ball_Y
	cmp #180	;180
	bne Check_Other_Wall
	
	lda Ball_Status

	and #%11111110
	jmp Store_Status
	
Check_Other_Wall

	lda Ball_Y
	cmp #3		;1
	bne No_CX_BL_PF
	
	lda Ball_Status

	ora #%00000001

Store_Status
	sta Ball_Status
No_CX_BL_PF
	

	lda Ball_Status
	and #%00000010
	bne Move_Ball_left
	
	dec Ball_X
	jmp Done_Moving_Ball_X
	
Move_Ball_left
	inc Ball_X
	
Done_Moving_Ball_X

	bit CXM0FB
	bvc Check_Other_Player

	lda Ball_Status
	ora #%00000010
	jmp Store_LR_Status
	
Check_Other_Player

	bit CXM1FB
	bvc Dont_Store_LR_Status
	

	
	lda Ball_Status
	and #%11111101


Store_LR_Status

	sta Ball_Status
	sta CXCLR


Dont_Store_LR_Status



	lda Ball_X
	cmp #$FE		;1
	bne Check_Other_X
	
	

	
	jmp Start_New_Round
	
Check_Other_X

	lda Ball_X
	cmp #160	;156
	bne Done_Update_Score
	
	
	
	
Start_New_Round


	

	
;No_New_Game	

	lda #70		;80
	sta Ball_X
	sta Ball_Y
	sta Game

Done_Update_Score

Skip_Logic

Overscan
	lda INTIM
	bpl Overscan



	jmp Start_Frame
	


;Score_Graphics

Positions
	.byte #140,#0


	

	echo "----",($FFFC - *) ," bytes left"
	
	org $FFFC
	.word Start
	.byte "RS"
